

   MEMBER('CM_System_DateTime_Tests.clw')                  ! This is a MEMBER module

                     MAP
                       INCLUDE('CM_SYSTEM_DATETIME_TESTS001.INC'),ONCE        !Local module procedure declarations
                     END


Main PROCEDURE !Procedure not yet defined
  CODE
  GlobalErrors.ThrowMessage(Msg:ProcedureToDo,'Main')      ! This procedure acts as a place holder for a procedure yet to be defined
  SETKEYCODE(0)
  GlobalResponse = RequestCancelled                        ! Request cancelled is the implied action
SetClarionDate_GetExcelDate_Verify PROCEDURE  (*long addr) ! Declare Procedure
DateTime                                class(CM_System_DateTime)
Testit                                      PROCEDURE
										end
  CODE
    addr = address(UnitTestResult)
    BeginUnitTest('SetClarionDate_GetExcelDate_Verify')
    !-------------------------------------------------------------------
    ! Write your code to test for a result, using the AssertThat syntax.
    ! At present there are two different assertions you can use, IsEqualto
    ! and IsNotEqualTo. You can pass in any data type that Clarion can
    ! automatically convert to a string. 
    ! 
    ! 	AssertThat('a',IsEqualTo('a'),'this is an optional extra message')
    !	AssertThat(1,IsNotEqualTo(2))
    !
    ! As soon as an Assert statement fails there remaining tests will
    ! not be executed. 
    !-------------------------------------------------------------------
    
  Datetime.Testit()
    DO ProcedureReturn
ProcedureReturn   ROUTINE
    return 0
Datetime.Testit     PROCEDURE
	CODE
	DateTime.SetDate(Date(3,25,2011)) ! TestClarionDate
	AssertThat(DateTime.GetExcelDate(),IsEqualTo(DateTime.GetDate() - self.GetExcelDateOffsetAfter_Feb28_1900()),'Wrong Excel date A')
	DateTime.SetDate(Date(1,25,1900)) ! TestClarionDate
	AssertThat(DateTime.GetExcelDate(),IsEqualTo(DateTime.GetDate() - self.GetExcelDateOffsetBefore_March1_1900()),'Wrong Excel date B')
	DateTime.SetDate(Date(2,28,1900)) ! TestClarionDate
	AssertThat(DateTime.GetExcelDate(),IsEqualTo(DateTime.GetDate() - self.GetExcelDateOffsetBefore_March1_1900()),'Wrong Excel date C')
	DateTime.SetDate(Date(2,29,1900)) ! TestClarionDate
	AssertThat(DateTime.GetExcelDate(),IsEqualTo(DateTime.GetDate() - self.GetExcelDateOffsetAfter_Feb28_1900()),'Wrong Excel date D')
	DateTime.SetDate(Date(3,1,1900)) ! TestClarionDate
	AssertThat(DateTime.GetExcelDate(),IsEqualTo(DateTime.GetDate() - self.GetExcelDateOffsetAfter_Feb28_1900()),'Wrong Excel date E')
	DateTime.SetDate(Date(1,1,1900)) ! TestClarionDate
	AssertThat(DateTime.GetExcelDate(),IsEqualTo(1),'Wrong Excel date - January 1 should be = 1')
SetClarionDate_GetClarionDate_Verify PROCEDURE  (*long addr) ! Declare Procedure
DateTime                                    CM_System_DateTime 
TestClarionDate                             equate(76788)
  CODE
    addr = address(UnitTestResult)
    BeginUnitTest('SetClarionDate_GetClarionDate_Verify')
    !-------------------------------------------------------------------
    ! Write your code to test for a result, using the AssertThat syntax.
    ! At present there are two different assertions you can use, IsEqualto
    ! and IsNotEqualTo. You can pass in any data type that Clarion can
    ! automatically convert to a string. 
    ! 
    ! 	AssertThat('a',IsEqualTo('a'),'this is an optional extra message')
    !	AssertThat(1,IsNotEqualTo(2))
    !
    ! As soon as an Assert statement fails there remaining tests will
    ! not be executed. 
    !-------------------------------------------------------------------
    
	DateTime.SetDate(Date(3,25,2011)) ! TestClarionDate
	AssertThat(DateTime.GetDate(),IsEqualTo(TestClarionDate),'Wrong Clarion date')
    DO ProcedureReturn
ProcedureReturn   ROUTINE
    return 0
SetClarionDateWhichIsInvalidExcelDate_VerifyError PROCEDURE  (*long addr) ! Declare Procedure
DateTime                                                CM_System_DateTime
  CODE
    addr = address(UnitTestResult)
    BeginUnitTest('SetClarionDateWhichIsInvalidExcelDate_VerifyError')
    !-------------------------------------------------------------------
    ! Write your code to test for a result, using the AssertThat syntax.
    ! At present there are two different assertions you can use, IsEqualto
    ! and IsNotEqualTo. You can pass in any data type that Clarion can
    ! automatically convert to a string. 
    ! 
    ! 	AssertThat('a',IsEqualTo('a'),'this is an optional extra message')
    !	AssertThat(1,IsNotEqualTo(2))
    !
    ! As soon as an Assert statement fails there remaining tests will
    ! not be executed. 
    !-------------------------------------------------------------------
    
	DateTime.SetDate(Date(12,31,1899)) 
	AssertThat(DateTime.GetExcelDate(),IsEqualTo(-1),'Wrong error value for invalid Excel date')
    DO ProcedureReturn
ProcedureReturn   ROUTINE
    return 0
CreateInavlidClarionDate_VerifyErrorCondition PROCEDURE  (*long addr) ! Declare Procedure
  CODE
    addr = address(UnitTestResult)
    BeginUnitTest('CreateInavlidClarionDate_VerifyErrorCondition')
    !-------------------------------------------------------------------
    ! Write your code to test for a result, using the AssertThat syntax.
    ! At present there are two different assertions you can use, IsEqualto
    ! and IsNotEqualTo. You can pass in any data type that Clarion can
    ! automatically convert to a string. 
    ! 
    ! 	AssertThat('a',IsEqualTo('a'),'this is an optional extra message')
    !	AssertThat(1,IsNotEqualTo(2))
    !
    ! As soon as an Assert statement fails there remaining tests will
    ! not be executed. 
    !-------------------------------------------------------------------
    
	AssertThat(Date(1,1,1700),IsEqualTo(-1))
    DO ProcedureReturn
ProcedureReturn   ROUTINE
    return 0
SetClarionDateFor2011_GetExcelDate_Verify PROCEDURE  (*long addr) ! Declare Procedure
DateTime                                CM_System_DateTime
  CODE
    addr = address(UnitTestResult)
    BeginUnitTest('SetClarionDateFor2011_GetExcelDate_Verify')
    !-------------------------------------------------------------------
    ! Write your code to test for a result, using the AssertThat syntax.
    ! At present there are two different assertions you can use, IsEqualto
    ! and IsNotEqualTo. You can pass in any data type that Clarion can
    ! automatically convert to a string. 
    ! 
    ! 	AssertThat('a',IsEqualTo('a'),'this is an optional extra message')
    !	AssertThat(1,IsNotEqualTo(2))
    !
    ! As soon as an Assert statement fails there remaining tests will
    ! not be executed. 
    !-------------------------------------------------------------------
    
	DateTime.SetDate(Date(3,25,2011)) ! TestClarionDate
	AssertThat(DateTime.GetExcelDate(),IsEqualTo(40627),'Wrong Excel date')
    DO ProcedureReturn
ProcedureReturn   ROUTINE
    return 0
IsItHappyHourYet_verify PROCEDURE  (*long addr)            ! Declare Procedure
  CODE
    addr = address(UnitTestResult)
    BeginUnitTest('IsItHappyHourYet_verify')
    !-------------------------------------------------------------------
    ! Write your code to test for a result, using the AssertThat syntax.
    ! At present there are two different assertions you can use, IsEqualto
    ! and IsNotEqualTo. You can pass in any data type that Clarion can
    ! automatically convert to a string. 
    ! 
    ! 	AssertThat('a',IsEqualTo('a'),'this is an optional extra message')
    !	AssertThat(1,IsNotEqualTo(2))
    !
    ! As soon as an Assert statement fails there remaining tests will
    ! not be executed. 
    !-------------------------------------------------------------------
    
	AssertThat(True,IsEqualTo(true),'Only fails on Mike''s machine','Yes!!!')
    DO ProcedureReturn
ProcedureReturn   ROUTINE
    return 0
ExcelTests           PROCEDURE                             ! Declare Procedure
  CODE
ClarionTests         PROCEDURE                             ! Declare Procedure
  CODE
