﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using CraigLabs.Common;
using ICSharpCode.SharpDevelop;

namespace ClarionMagSearch
{
    public partial class SearchPadControl : UserControl
    {
        public SearchPadControl()
        {
            InitializeComponent();
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {

            StringBuilder sb = new StringBuilder(String.Empty);
            if (!string.IsNullOrEmpty(tbAuthor.Text))
            {
                sb.Append("author:" + tbAuthor.Text);
            }
            if (!string.IsNullOrEmpty(tbTitle.Text))
            {
                if (sb.Length > 0) 
                    sb.Append("+");
                sb.Append("title:" + tbTitle.Text);
            }
            if (!string.IsNullOrEmpty(tbText.Text))
            {
                if (sb.Length > 0)
                    sb.Append("+");
                sb.Append(tbText.Text);
            }
            if (sb.Length > 0)
            {
                sb.Insert(0, "http://www.clarionmag.com/search/find?searchTerm=");
                if (cbUseEmbeddedBrowser.Checked == true)
                {
                    FileService.OpenFile(sb.ToString());
                }
                else
                {
                    System.Diagnostics.Process.Start(sb.ToString());
                }
            }
        }
    }
}
